
g=function(y,n) gamma(y+n)/gamma(y)

s=function(i,j,k2,a1,a2)
  {
    f=(-1)^j*g(0.5,i+j)*a1^i*a2^(j+k2)/(gamma(i+1)*gamma(j+1))
    return(f)
  }


# ZONAL POLYNOMIAL
C=function(k1,k2,a1,a2)
  {
    k=k1-k2
    even=floor(k/2)==k/2
    if(even){
      summa=0
      for(i in 0:(k/2))summa=summa+s(2*i,k/2-i,k2,a1,a2)
    }else    
    {
      summa=0
      for(i in 0:((k-1)/2))summa=summa+s(2*i+1,(k-1)/2-i,k2,a1,a2)
    }
    zonal=2^(2*k1)*(2*k+1)*gamma(k1+1)*gamma(k1+k2+1)*summa/(gamma(k2+1)*gamma(2*k1+2))
    return(zonal)
  }


# BIVARIATE POISSON PROBABILITIES
prob=function(x1,x2,mu,rho)
  {
    a1=mu
    a2=rho*mu^2/4
    p=C(x1,x2,a1,a2)*exp(-a1)/gamma(x1+x2+1)
    return(p)
  }

# LOG-LIKELIHOOD
logl=function(th,x1,x2,max.score)
  {
    n=length(x1)
    mu=th[1]
    rho=th[2]    
    pr=0
    for(i in 0:max.score)
      {
        for(j in 0:i)
          {
            if(i+j<=max.score)
              {
                pr=pr+prob(i,j,mu,rho)
#                print(c(i,j))
              }
          }
      }
    px=1-pr
    ll=0
    for(i in 1:n)
      {
        if(x1[i]+x2[i]>max.score)
          {
            pin=px
            }else
        {
          pin=prob(x1[i],x2[i],mu,rho)
        }
#        if(pin<=0)print(c(pin,x1[i],x2[i]))
        ll=ll+log(pin)
      }
    ll=-ll
    return(ll)
  }

# ESTTIMATE-FUNCTION
est=function(filename,max.score)
# THE DATA IN THE FILE "filename" MUST BE ON THE RESULT-FORM, E.G.
# 1;0
# 1;3
# 2;2
# WHERE THE ORDER OF THE HOME AND AWAY TEAMS IS IRRELEVANT
# max.score IS THE TRUNCATION OF THE MAXIMUM NUMBER OF SCORED
# GOALS IN A GAME
  {
    england=read.csv(filename,sep=";",header=F)
    K1=england[,1]
    K2=england[,2]
    x1=pmax(K1,K2)
    x2=pmin(K1,K2)
    mu.start=mean(x1+x2)
    rho.start=1
    th=c(mu.start,rho.start)
    estim=optim(th,logl,x1=x1,x2=x2,max.score=max.score)$par
    return(estim)
  }


# EXAMPLE
est("England2007.csv",max.score=5)
